# ungleich cli

This CLI is used for day-to-day tasks used at ungleich.
It is intended to be used by ungleich engineers and skilled customers.

## Requirements / Installation

* ensure you have **python3** and **pipenv**
* git clone this repo
* cd into this repo
* run the following command
```
pipenv install
pipenv shell
```

## Usage general

```
ungleich --help
```
## Usage: Weather

```
ungleich weather
```

## Usage: Config

```
ungleich config-add \
    --name <otp username>
    --realm <otp realm>
    --seed <otp seed>
```

## Usage: DNS

```
ungleich dns \
    --set-reverse <ip> 
    --user <user_id> 
    --email <email> 
    --name mirror.example.com
```

### Usage: RIPE

Creating a new route6 object:

```
ungleich ripe-add-route6 \
    --network 2a09:2947::/32
    --description "First REST /32"
    --password "very secure"
```

### Usage: Account

Creating a new account object:

```
ungleich account \
    --create-user <username> 
    --name <firstname> 
    --lastname <lastname> 
    --email <email>
```

### Usage: SSH Key

Requires you to have
https://code.ungleich.ch/ungleich-public/ungleich-ssh-keys/ checked
out in ~/vcs/ungleich-ssh-keys


```
ungleich sshkey  --key raul.ascencio --host dev.raul.ungleich.cloud
```
